ForeignMultiKeyNullifier (Oracle - Berkeley DB Java API)
Date: 2013-09-09

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 5.3.28
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sleepycat.db
Interface ForeignMultiKeyNullifier

    public interface ForeignMultiKeyNullifier

The interface implemented for setting multi-valued foreign keys to null.

A key nullifier is used with a secondary database that is configured to have a foreign key integrity constraint and a delete action of `ForeignKeyDeleteAction.NULLIFY`. The key nullifier is specified by calling `SecondaryConfig.setForeignMultiKeyNullifier(com.sleepycat.db.ForeignMultiKeyNullifier)`.

When a referenced record in the foreign key database is deleted and the foreign key delete action is `NULLIFY`, the `nullifyForeignKey(com.sleepycat.db.SecondaryDatabase, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry, com.sleepycat.db.DatabaseEntry)` method is called. This method sets the foreign key reference to null in the datum of the primary database. The primary database is then updated to contain the modified datum. The result is that the secondary key is deleted.

This interface may be used along with `SecondaryKeyCreator` or `SecondaryMultiKeyCreator` for many-to-many, one-to-many, many-to-one and one-to-one relationships.

Method Summary
`boolean` | `nullifyForeignKey(SecondaryDatabase secondary, DatabaseEntry key, DatabaseEntry data, DatabaseEntry secKey)` Sets the foreign key reference to null in the datum of the primary database.

Method Detail

### nullifyForeignKey

    boolean nullifyForeignKey(SecondaryDatabase secondary,
                              DatabaseEntry key,
                              DatabaseEntry data,
                              DatabaseEntry secKey)
                              throws DatabaseException

  Sets the foreign key reference to null in the datum of the primary database.

  Parameters:
    `secondary` - the database in which the foreign key integrity constraint is defined. This parameter is passed for informational purposes but is not commonly used.
    `key` - the existing primary key. This parameter is passed for informational purposes but is not commonly used.
    `data` - the existing primary datum in which the foreign key reference should be set to null. This parameter should be updated by this method if it returns true.
    `secKey` - the secondary key to be nullified. This parameter is needed for knowing which key to nullify when multiple keys are present, as when `SecondaryMultiKeyCreator` is used.
  Returns:
    true if the datum was modified, or false to indicate that the key is not present.
  Throws:
    `DatabaseException` - if an error occurs attempting to clear the key reference.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 5.3.28
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 1996, 2013 Oracle and/or its affiliates. All rights reserved.